unit U_SpringMass2_mX4_21;
 {Copyright   00-07, Gary Darby,  www.DelphiForFun.org
 This program may be used or modified for any non-commercial purpose
 so long as this original notice remains in place.
 All other rights are reserved
 }

 {A simple animated spring-mass demo with initial consditions,
  gravity, and damping}

interface

{uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, ShellAPI;   }

type
  aFloat=single;
type
  (*TSpring=class(tPanel)
    private
      Image:TImage;
    public
      K:Float;   {spring constant}
      M:Float;   {mass}
      G:Float;   {gravity}
      A:Float;   {acceleration}
      x:Float;   {displacement}
      v:Float;   {velocity}
      C:Float;   {damping}
      X0:Float;  {initial displacement}
      //F0:Float;  {initial force}
      V0:Float;  {initial velocity}


      XEnd:Float; {resting displacement G*M/K}
      InitiallyConstrained:Boolean;
      Timeinc:Float;
      Scale:float;
      Stype:integer;  {spring type, 0 - pull only, 1= push/pull}
      delay:integer; {ms wait between frames while animating}
      pts:array of TPoint; {points drawn, used to erase spring}
      step:integer;  {pixel increment while drawinga spring}
      wraps:integer; {nbr of coils in spring}
      drawColor:TColor;
      constructor create (Aowner:TPanel; r:Trect); reintroduce;
      procedure drawspring(Len:float);
      procedure erasespring;
      procedure redrawinitial;
      function Setup({newF0,}newV0,newX0,newC,newK,newM, newG, newTimeInc:Float;
                      newconstraint:boolean;
                      Nbrloops,newStep,newdelay:integer;
                      newcolor:TColor):boolean;
      procedure animate;
      procedure animate2(===);
      procedure sizechanged(sender:TObject);
      function GetMaxAmp:float;
  end;  *)


  TForm1 = {class(}TForm;
  var
    Panel1: TPanel;
    aMemo1: TMemo;
    Panel2: TPanel;
    Label2: TLabel;
    V0Edt: TEdit;
    Label4: TLabel;
    DampEdt: TEdit;
    Label5: TLabel;
    SpringEdt: TEdit;
    Label6: TLabel;
    MassEdt: TEdit;
    Label8: TLabel;
    GravityEdt: TEdit;
    ConstraintRgrp: TRadioGroup;
    X0Edt: TEdit;
    TypeRgrp: TRadioGroup;
    StartBtn: TButton;
    aMemo2: TMemo;
    TimeScaleGrp: TRadioGroup;
    Label1: TLabel;
    TimeIncEdt: TEdit;
    StopBtn: TButton;
    aMemo3: TMemo;
    StaticText1: TStaticText;
    Displaybox: TCheckBox;
       procedure StartBtnClick(Sender: TObject);
       procedure StopBtnClick(Sender: TObject);
       procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
       procedure X0EdtChange(Sender: TObject);
       procedure DampEdtChange(Sender: TObject);
       procedure SpringEdtChange(Sender: TObject);
       procedure MassEdtChange(Sender: TObject);
       procedure EdtKeyPress(Sender: TObject; var Key: Char);
       procedure FormCreate(Sender: TObject);
       procedure EdtKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
       procedure FormActivate(Sender: TObject);
       procedure GravityEdtChange(Sender: TObject);
       procedure ConstraintRgrpClick(Sender: TObject);
       procedure TypeRgrpClick(Sender: TObject);
       procedure TimeIncEdtExit(Sender: TObject);
       procedure TimeScaleGrpClick(Sender: TObject);
       procedure StaticText1Click(Sender: TObject);
       procedure V0EdtChange(Sender: TObject);
  //private
    { Private declarations }
  //public
    { Public declarations }
    var 
    spring1:TSpring;
    timescale:afloat;
    timeinc:afloat;
    function setup:boolean;
  //end;

var
  Form1: TForm1;

implementation

//{$R *.DFM}

//uses math;

const
  {we'll just use constants for these for now}
  nbrloops=4;   {wiggles in the spring}
  resolution=2; {pixel step when drawing spring}
var
  delayms:integer; //=10;   {ms delay bewteen frames while animating}



{******************* TForm1 Methods *****************}

{*************** StartBtnClick ******************}
procedure StartBtnClick(Sender: TObject);
{user clicked Start button}
var
  omega:afloat;
begin
  if setup then begin
    panel2.enabled:=false;
    panel2.sendtoback;
    form1.cursor:=crhourglass;
    aMemo3.clear;
    with spring1, amemo3.lines do begin
      omega:=sqrt(spring1.k/spring1.m)/(2*pi);
      add(format('Osc. Freg: %6.2f Hz',[omega]));
      add(format('Period: %5.1f sec.c',[1/omega]));
    end;  
    //spring1.Animate(form1, amemo2);
    if displaybox.checked then 
      spring1.Animate2(form1, amemo2, true) else
      spring1.Animate2(form1, amemo2, false);
    form1.cursor:=crdefault;
    panel2.enabled:=true;
    panel2.bringtofront;
  end;
end;

{^^^^^^^^^^^^^ StopBtnClick **************}
procedure StopBtnClick(Sender: TObject);
{User clicked stop button}
begin
  panel2.enabled:=true;
  panel2.bringtofront;
  spring1.tag:=1;
end;

{**************** FormCloseQuery ****************}
procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
{Stop spring if running and allow program close}
begin
  spring1.tag:=1;
  canclose:=true;
end;


{******************* X0EdtChange *************}
procedure X0EdtChange(Sender: TObject);
{Set initial weight position}
begin
  constraintrgrp.itemindex:=1;
  if TEdit(sender).text='-' then exit;
  constraintrgrpclick(sender);
end;

procedure V0EdtChange(Sender: TObject);
var
  x:afloat;
begin
   spring1.V0:=StrToFloat(V0Edt.text);
end;


{****************** DampEdtChange **************}
procedure DampEdtChange(Sender: TObject);
var x:afloat;
begin
  if TEdit(sender).text<>'-' then
  begin
    x:=StrToFloat(DampEdt.text);
    spring1.C:=x;
    if (x>=0) and (x<=1) and (spring1.k>0)  then spring1.redrawinitial;   {redraw  spring if valid}
  end;
end;

{*************** SpringEdtChange ***************}
procedure SpringEdtChange(Sender: TObject);
var x:afloat;
begin
  If TEdit(sender).text<>'-' then
  begin
    x:=StrToFloat(SpringEdt.text);
    spring1.K:=x;
    if (x>0) and (x>0) then spring1.redrawinitial; {redraw  spring if valid}
  end ;
end;

{************** MassEdtChange ****************}
procedure MassEdtChange(Sender: TObject);
begin
  If TEdit(sender).text<>'-' then
  begin
    spring1.m:=strtofloat(massedt.text);
    spring1.redrawInitial;
  end;
end;

{****************** GravityEdtChange *************}
procedure GravityEdtChange(Sender: TObject);
var x:afloat;
begin
  If TEdit(sender).text<>'-' then
  begin
    x:=StrToFloat(GravityEdt.text);
    spring1.G:=x;
    if x>0 then spring1.redrawInitial; {redraw  spring if valid}
  end;
end;

procedure TimeIncEdtExit(Sender: TObject);
var x:afloat;
    errmsg:string;
begin
  errmsg:='';
  x:=1;
  try
    x:=StrToFloat(Timeincedt.text);
    except
    //on eConvertError do
       errmsg:='Time increment per calc loop must be between 0.01 and 1.0';
      writeln(errmsg) 
  end;
  if (errmsg='') and ((x<0.009) or (x>1.0)) then  
          errmsg:='Time increment per calc loop must be between 0.01 and 1.0';
  if errmsg=''
  then timeinc:=(round(100.0*x)) /100.0
  else showmessage(errmsg);
  timeincedt.text:=format('%5.2f',[timeinc]);
end;

 const abackspace=#8;
{**************** EdtKeyPress **************}
procedure EdtKeyPress(Sender: TObject; var Key: Char);
{Validate numeric entry for floating point number entries}
//const backspace=#8; {backspace character}
begin
  If sender is TEdit then
  Begin
    //if Key in [abackspace, '0'..'9'] then exit;
    if Key in StrToCharSet(DIGISET + abackspace) then exit;
    if (key ='.')  or  (key = ',') then key:=decimalseparator;
    if (Key = decimalseparator) and (Pos(decimalseparator, TEdit(sender).Text) = 0)
    then exit;
    if (Key = '-') and (TEdit(sender).SelStart = 0)
     and (pos('-',TEdit(sender).text)=0) then  exit;
    Key := #0;
    beep;
  end;
end;


{*************** FormCreate ************}
procedure FormCreate(Sender: TObject);
{Make the spring object}
begin
   delayms:= 10; //=10;
   spring1:=TSpring.create(panel1,rect(100,10,150,panel1.height-50));
   V0Edt.text:='30'+decimalseparator+'0';
   DampEdt.text:='0'+decimalseparator+'05';
   SpringEdt.text:='5'+decimalseparator+'0';
   MassEdt.text:='15'+decimalseparator+'0';
   GravityEdt.text:='9'+decimalseparator+'81';
   TimeIncEdt.text:='1'+decimalseparator+'0';

  stopbtn.top:=panel2.top+startbtn.top;
  stopbtn.left:=panel2.left+startbtn.left;

  timescalegrpclick(sender);
  timeincedtexit(sender);
  writeln('form created..')
end;

{***************** EdtKeyUp ***************}
procedure EdtKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{Keep a valid number in the field by change a blank to 0}
begin
  with TEdit(sender) do if text='' then text:='0';
end;

{***************** Setup ****************}
function Setup:boolean;
begin
  typergrpclick(self);
  delayms:=trunc(1000*timescale*timeinc);
  result:=spring1.Setup(strtofloat(V0Edt.text),
                strtofloat(X0Edt.text),
                strtofloat(DampEdt.text),
                strtofloat(SpringEdt.text),
                strtofloat(Massedt.text),
                strtofloat(GravityEdt.text),
                strtofloat(timeincedt.text),
                constraintrgrp.itemindex=1,
                Nbrloops,resolution,delayms,clBlack);
end;

{*************** FormActivate ****************}
procedure FormActivate(Sender: TObject);
{Initialization stuff}
begin   
  setup;
  writeln('form activated..');  

end;

{**************** ConstraintRGrpClick **************}
procedure ConstraintRgrpClick(Sender: TObject);
{Set initial constraint property in Tspring object}
begin
  spring1.InitiallyConstrained:=constraintRgrp.itemindex=1;
  setup;
  {spring1.redrawinitial;}
end;

{*************** TypeRGrpClick ^^^^^^^^^^^^^}
procedure TypeRgrpClick(Sender: TObject);
{Set spring type property in TSpring object}
begin
  spring1.stype:=Typergrp.itemindex;
end;


procedure TimeScaleGrpClick(Sender: TObject);
begin
  timescale:=1/round(intpower(2.0,timescalegrp.itemindex));
  delayms:=trunc(1000*timescale*timeinc);
end;

procedure StaticText1Click(Sender: TObject);
begin
  //  ShellExecute(Handle, 'open', 'http://www.delphiforfun.org/',
                           //nil, nil, SW_SHOWNORMAL) ;
  openWeb('http://delphiforfun.org/Programs/Spring_Mass_1.htm');
end;

procedure loadspringmassform;
begin
 Form1:= TForm1.create(self);
 with form1 do begin
  Left := 187
  Top := 55
  Width := 800
  Height := 600
  Caption := 'SpringMass V2 - Displays detail data in mX4 '
  Color := clBtnFace
  Font.Charset := DEFAULT_CHARSET
  Font.Color := clWindowText
  Font.Height := -11
  Font.Name := 'MS Sans Serif'
  Font.Style := []
  OldCreateOrder := False
  Position := poScreenCenter
  OnActivate := @FormActivate;
  OnCloseQuery := @FormCloseQuery
  OnCreate := @FormCreate
  PixelsPerInch := 96
  //TextHeight := 13
  stopBtn:= TButton.create(form1)
  with stopbtn do begin
   parent:= form1;
    Left := 200
    Top := 120
    Width := 97
    Height := 25
    Caption := 'Stop'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clRed
    Font.Height := -16
    Font.Name := 'MS Sans Serif'
    Font.Style := [fsBold]
    ParentFont := False
    TabOrder := 4
    OnClick := @StopBtnClick
  end ;
  Panel1:= TPanel.create(form1)
  with panel1 do begin
   parent:= form1;
    Left := 320
    Top := 16
    Width := 209
    Height := 513
    TabOrder := 0
  end;
   aMemo1:= TMemo.create(form1)
   with amemo1 do begin
    parent:= form1;
    Left := 16
    Top := 16
    Width := 289
    Height := 113
    TabStop := False
    Color := clYellow
    Lines.add (
      'Program demonstating animation of a simple spring-mass '
      +'system with damping.   Units are arbitrary.'
      +''+CRLF+CRLF
      +'Constraints: Mass and spring constant must be greater than '
      +'0.  Damping can range from  0 to 1,  Gravity must not be '
      +'negative.'
      +''+CRLF
      +'Detailed results for up to 2000 iterations may be displayed.')
    TabOrder := 1
  end;
  Panel2:= TPanel.create(form1)
  with panel2 do begin
   parent:= form1;
    Left := 16
    Top := 144
    Width := 289
    Height := 385
    TabOrder := 2
    Label2:= TLabel.create(form1)
    with label2 do begin
     parent:= panel2;
      Left := 27
      Top := 88
      Width := 64
      Height := 33
      AutoSize := False
      Caption := 'Initial Velocity (+:=down)'
      WordWrap := True
    end ;
    Label4:= TLabel.create(form1)
    with label4 do begin
     parent:= panel2;
      Left := 47
      Top := 128
      Width := 42
      Height := 13
      Caption := 'Damping'
    end;
    Label5:= TLabel.create(form1)
    with label5 do begin
     parent:= panel2;
      Left := 14
      Top := 156
      Width := 75
      Height := 13
      Caption := 'Spring Constant'
    end ;
    Label6:= TLabel.create(form1)
    with label6 do begin
     parent:= panel2;
      Left := 64
      Top := 188
      Width := 25
      Height := 13
      Caption := 'Mass'
    end;
    Label8:= TLabel.create(form1)
    with label8 do begin
     parent:= panel2;
      Left := 56
      Top := 220
      Width := 33
      Height := 13
      Caption := 'Gravity'
    end;
    Label1:= TLabel.create(form1)
    with label1 do begin
     parent:= panel2;
      Left := 16
      Top := 252
      Width := 81
      Height := 29
      AutoSize := False
      Caption := 'Time inc/loop  0.1 to 1.0 secs.'
      WordWrap := True
    end;
    ConstraintRgrp:= TRadioGroup.create(form1)
    with constraintrgrp do begin
     parent:= panel2
      Left := 16
      Top := 0
      Width := 265
      Height := 81
      Caption := 'Weight position'
      ItemIndex := 0
      Items.add ('Unconstrained initiial postion');
       Items.add('Intial displacement from rest');
       ItemIndex := 0
      TabOrder := 0
      OnClick := @ConstraintRgrpClick
    end;
    V0Edt:= TEdit.create(form1)
    with v0edt do begin
     parent:= panel2;
      Left := 104
      Top := 92
      Width := 49
      Height := 21
      Font.Charset := DEFAULT_CHARSET
      Font.Color := 20
      Font.Height := -11
      Font.Name := 'MS Sans Serif'
      Font.Style := []
      ParentFont := False
      TabOrder := 2
      Text := '30'
      OnChange := @V0EdtChange;
      OnKeyPress := @EdtKeyPress;
      OnKeyUp := @EdtKeyUp;
    end ;
    dampEdt:= TEdit.create(form1)
    with dampedt do begin
     parent:= panel2;
      Left := 104
      Top := 124
      Width := 49
      Height := 21
      TabOrder := 3
      Text := '0.05'
      OnChange := @DampEdtChange
      OnKeyPress := @EdtKeyPress
      OnKeyUp := @EdtKeyUp
    end;
    //object SpringEdt: TEdit
    springEdt:= TEdit.create(form1)
    with springedt do begin
     parent:= panel2;
      Left := 104
      Top := 156
      Width := 49
      Height := 21
      TabOrder := 4
      Text := '5'
      OnChange := @SpringEdtChange
      OnKeyPress := @EdtKeyPress
      OnKeyUp := @EdtKeyUp
    end;
    massEdt:= TEdit.create(form1)
    with massedt do begin
     parent:= panel2;
      Left := 104
      Top := 188
      Width := 49
      Height := 21
      Font.Charset := DEFAULT_CHARSET
      Font.Color := 25
      Font.Height := -11
      Font.Name := 'MS Sans Serif'
      Font.Style := []
      ParentFont := False
      TabOrder := 5
      Text := '15'
      OnChange := @MassEdtChange
      OnKeyPress := @EdtKeyPress
      OnKeyUp := @EdtKeyUp
    end ;
    gravityEdt:= TEdit.create(form1)
    with gravityedt do begin
     parent:= panel2; 
      Left := 104
      Top := 220
      Width := 49
      Height := 21
      TabOrder := 6
      Text := '9.81'
      OnChange := @GravityEdtChange
      OnKeyPress := @EdtKeyPress
      OnKeyUp := @EdtKeyUp
    end ;
    X0Edt:= TEdit.create(form1)
    with X0edt do begin
     parent:= panel2;
      Left := 192
      Top := 48
      Width := 49
      Height := 21
      TabOrder := 1
      Text := '100'
      OnChange := @X0EdtChange
      OnKeyPress := @EdtKeyPress
      OnKeyUp := @EdtKeyUp
    end ;
    //object TypeRgrp: TRadioGroup
    TypeRgrp:= TRadioGroup.create(form1)
    with typergrp do begin
     parent:= panel2
      Left := 176
      Top := 96
      Width := 97
      Height := 73
      Caption := 'Spring type'
      ItemIndex := 1
      Items.add('Pull only' );
       Items.add('Push/Pull')
       ItemIndex := 1
      TabOrder := 8
      OnClick := @TypeRgrpClick
    end;
    StartBtn:= TButton.create(form1)
    with startbtn do begin
     parent:= panel2;
      Left := 16
      Top := 328
      Width := 97
      Height := 25
      Caption := 'Start'
      TabOrder := 11
      OnClick := @StartBtnClick
    end;
    timescalegrp:= TRadioGroup.create(form1)
    with timescalegrp do begin
     parent:= panel2
      Left := 176
      Top := 184
      Width := 97
      Height := 89
      Caption := 'Time Scale'
      ItemIndex := 3
      Items.add('Real time')
      Items.add('2X')
      Items.add('4X')
      Items.add('8X')
      ItemIndex := 3
      TabOrder := 9
      OnClick := @TimeScaleGrpClick
    end;
    //object TimeIncEdt: TEdit
    TimeIncEdt:= TEdit.create(form1)
    with TimeIncEdt do begin
     parent:= panel2;
      Left := 104
      Top := 252
      Width := 49
      Height := 21
      TabOrder := 7
      Text := '0.1'
      OnExit := @TimeIncEdtExit
      OnKeyPress := @EdtKeyPress
      OnKeyUp := @EdtKeyUp
    end ;
    aMemo3:= TMemo.create(form1)
    with amemo3 do begin
     parent:= panel2;
      Left := 144
      Top := 312
      Width := 121
      Height := 57
      TabStop := False
      ReadOnly := True
      TabOrder := 12
    end;
    displaybox:= TCheckBox.create(form1)
    with displaybox do begin
     parent:= panel2;
      Left := 144
      Top := 280
      Width := 129
      Height := 17
      Caption := 'Display detail data'
      Checked := True
      State := cbChecked
      TabOrder := 10
    end ;
  end;
  aMemo2:= TMemo.create(form1)
  with amemo2 do begin
   parent:= form1;
    Left := 544
    Top := 16
    Width := 233
    Height := 513
    TabStop := False
    Lines.add(
      'Time    A       V       Pos')
    ScrollBars := ssVertical
    TabOrder := 3
  end ;
   StaticText1:= TStaticText.create(form1)
   with statictext1 do begin
    parent:= form1;
    Left := 0
    Top := 542
    Width := 792
    Height := 20
    Cursor := crHandPoint
    Align := alBottom
    Alignment := taCenter
    Caption:= ' 2000, 2007, Gary Darby,  www.DelphiForFun.org,  maXbox4 2022';
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clBlue
    Font.Height := -13
    Font.Name := 'MS Sans Serif'
    Font.Style := [fsUnderline]
    ParentFont := False
    TabOrder := 5
    TabStop := True
    OnClick := @StaticText1Click
   end ;
  //Show;
  Formcreate(self);
  //Formactivate(self);
  Show;  //form1
 end;
end; 


begin //@main

  loadspringmassform;
  writeln('CPU Speed '+cpuspeed);

End.
